@use '../../../global/styles/styles-variables' as *;
@use './styles/code-example.variables' as *;

:host {
	@include digi-code-example--variables;

	display: block;
}

.digi-code-example {
	background-size: 20px 20px;
	background-position: 0 0, 0 10px, 10px -10px, -10px 0px;
	border: var(--digi--border-width--primary) solid var(--digi--color--border--neutral-2);
	height: 100%;
	display: flex;
	flex-direction: row;
	border-radius: 0.3rem;
	position: relative;
	
	@media (max-width: $digi--breakpoint--small-below){
		min-width: 360px;
	}

	&--light {
		background-color: #ffffff;
		background-image: linear-gradient(45deg, #efefef 25%, transparent 25%), linear-gradient(-45deg, #efefef 25%, transparent 25%), linear-gradient(45deg, transparent 75%, #efefef 75%), linear-gradient(-45deg, transparent 75%, #efefef 75%);
	}

	&--dark {
		background-color: #999999;
		background-image: linear-gradient(45deg, #666666 25%, transparent 25%), linear-gradient(-45deg, #666666 25%, transparent 25%), linear-gradient(45deg, transparent 75%, #666666 75%), linear-gradient(-45deg, transparent 75%, #666666 75%);
	}

	&__container {
		display: flex;
		flex-direction: column;
		justify-content: space-between;
		flex-grow: 1;
		position: relative;
	}

	&--no-controls {
		flex-direction: column;

		.digi-code-example__copy-button {
			margin-top: 0;
			align-self: flex-end;
			margin-bottom: 0.2rem;
			z-index: 1;
			position: absolute;
			bottom: 0;
			right: 0;

			&--dark {
				--digi--button--color--text--function--default: var(--digi--color--text--inverted);
				--digi--button--color--text--function--hover: var(--digi--color--text--inverted);
				--digi--button--color--icon--function--default: var(--digi--color--text--inverted);
				--digi--button--color--icon--function--hover: var(--digi--color--text--inverted);
			}
		}
	}

	&__example {
		padding: var(--digi--padding--largest-2);
		overflow-x: auto;
		@media (max-width: $digi--breakpoint--medium){
			padding: var(--digi--padding--medium);
		}
		@media (max-width: $digi--breakpoint--small-below){
			padding: var(--digi--padding--small);
		}
	}

	&__copy-button {
		align-self: start;
		margin-top: var(--digi--padding--large);
		margin-right: var(--digi--padding--small);
	}

	&__codeblock {
		digi-code-block {
			--digi--code-block--border-radius: 0;
			--digi--code-block--border: none;
		}
	}

	&__controls {
		padding: var(--digi--padding--medium);
		background: var(--digi--color--background--neutral-6);
		display: flex;
		flex: 0 var(--digi--code-example--controls--width);
		flex-direction: column;
		align-self: stretch;
		flex-shrink: 0;
		justify-content: space-between;
		gap: var(--digi--gutter--medium);
		@media (max-width: $digi--breakpoint--medium){
			padding: var(--digi--padding--smaller);
		}

		&[hidden] {
			display: none;
		}
	}

	&--inactive {
		.digi-code-example__code {
			display: flex;
			flex-direction: column;
			flex-grow: 1;

			&block {
				flex-grow: 1;
				height: 64px;
				overflow-y: hidden;
				position: relative;
			}
		}
	}

	&__code-expand {
		display: flex;
		align-items: center;
		justify-content: center;
		gap: var(--digi--gutter--icon);
		width: 100%;
		padding: 0.875rem 0;
		//background-color: var(--digi--color--background--inverted-1);
		//background: var(--digi--color--background--inverted-3);
		background: #272727;
		color: var(--digi--color--text--inverted);
		font-size: var(--digi--typography--body--font-size--desktop);
		font-family: var(--digi--global--typography--font-family--default);
		cursor: pointer;
		border: none;

		&:hover {
			background: var(--digi--color--background--inverted-3);
			//background-color: var(--digi--color--background--inverted-2);
			text-decoration: underline;
		}
	}
}

.digi-code-example--no-controls.digi-code-example--inactive {
	.digi-code-example__codeblock {
		height: 64px;
	}
}
.digi-code-example__copy-button {
	--digi--button--padding--small: 0;
	--digi--button--padding--medium: 0;
	--digi--button--padding--large: 0;
}

.digi-code-example__code-expand-icon {
	--digi--icon--color: var(--digi--color--text--inverted);
}

.digi-code-example__fade {
	position: absolute;
	width: 100%;
	bottom: 0;
	height: var(--digi--padding--largest-2);

	&--light {
		background-image: linear-gradient(0deg, white, transparent);
	}

	&--dark {
		--digi--color--background--inverted-3:#272727;
		background-image: linear-gradient(0deg, var(--digi--color--background--inverted-3), transparent);
		//background-image: linear-gradient(0deg, var(--digi--color--background--inverted-1), transparent);
	}
}

.slot__controls {
	margin-bottom: var(--digi--padding--smaller);
}

::slotted(* .slot__controls) {
	display: flex;
	flex-direction: column;
	gap: var(--digi--padding--smaller);
}

::slotted(* .slot__controls[hidden]) {
	display: none;
}

::slotted(* .slot__controls digi-form-fieldset),
::slotted(* .slot__controls digi-form-select),
::slotted(* .slot__controls digi-form-fieldset + digi-form-checkbox),
::slotted(* .slot__controls .divider) {
	display: block;
	border-bottom: 1px solid var(--digi--color--border--neutral-2);
	padding-bottom: var(--digi--padding--smaller);
	margin-bottom: var(--digi--padding--medium);
}
